#!/usr/local/bin/perl5 -w

foreach $filename (@ARGV) {
    if (-e "$filename.cpp") {
	print STDERR "$filename.cpp already exists\n";
	next;
    }
    if (-e "$filename.h") {
	print STDERR "$filename.h already exists\n";
	next;
    }

    $upperfilename = $filename;
    $upperfilename =~ tr/a-z/A-Z/;
    $upperfilename =~ s/[^A-Z]/_/g;

    print STDERR "Creating $filename.cpp\n";

    open (CPPFILE, ">$filename.cpp") || die "Couldn't write $filename.cpp";
    
    print CPPFILE "/**********************************************************************\n";
    print CPPFILE " *\n";
    print CPPFILE " * $filename.cpp -- \n";
    print CPPFILE " * Copyright (C) 1999  The New Zealand Digital Library Project\n";
    print CPPFILE " *\n";
    print CPPFILE " * PUT COPYRIGHT NOTICE HERE\n";
    print CPPFILE " *\n";
    print CPPFILE " * \$" . "Id: newsrc.pl,v 1.1 1999/01/21 04:02:03 rjmcnab Exp \$\n";
    print CPPFILE " *\n";
    print CPPFILE " *********************************************************************/\n";
    print CPPFILE "\n";
    print CPPFILE "/*\n";
    print CPPFILE "   \$" . "Log: newsrc.pl,v \$\n";
    print CPPFILE " */\n";
    print CPPFILE "\n";
    print CPPFILE "\n";
    print CPPFILE "#include \"$filename.h\"\n";
    print CPPFILE "\n";

    close (CPPFILE);


    print STDERR "Creating $filename.h\n";

    open (HFILE, ">$filename.h") || die "Couldn't write $filename.h";

    print HFILE "/**********************************************************************\n";
    print HFILE " *\n";
    print HFILE " * $filename.h -- \n";
    print HFILE " * Copyright (C) 1999  The New Zealand Digital Library Project\n";
    print HFILE " *\n";
    print HFILE " * PUT COPYRIGHT NOTICE HERE\n";
    print HFILE " *\n";
    print HFILE " * \$" . "Id: newsrc.pl,v 1.1 1999/01/21 04:02:03 rjmcnab Exp \$\n";
    print HFILE " *\n";
    print HFILE " *********************************************************************/\n";
    print HFILE "\n";
    print HFILE "\n";
    print HFILE "\#ifndef ${upperfilename}_H\n";
    print HFILE "\#define ${upperfilename}_H\n";
    print HFILE "\n";
    print HFILE "\n";
    print HFILE "\n";
    print HFILE "\n";
    print HFILE "\#endif\n";

    close (HFILE);
}

