# html classifier plugin - creates an empty classification
# that's simply a link to a web page
# options are:
# title=Title       -- (optional) the title field for this classification.
#                      if not included title field 'Browse'
# url=url           -- the url of the web page to link to

package HTML;

sub new {
    my ($class, @options) = @_;

    my ($title, $url);

    foreach $option (@options) {
	if ($option =~ /^url=(.*)$/i) {
	    $url = $1;
	} elsif ($option =~ /^title=(.*)$/i) {
	    $title = $1;
	}
    }

    die "Error: HTML classifier contains no 'url' option\n" 
	unless defined $url;

    $title = 'Browse' unless defined $title;

    return bless {
	'url' => $url,
	'title' => $title
	}, $class;
}

sub init {
    my $self = shift (@_);
}

sub classify {
    my $self = shift (@_);
    my ($doc_obj) = @_;

    # we don't do anything for individual documents
}

sub get_classify_info {
    my $self = shift (@_);

    my %classifyinfo = ('classifytype'=>'HTML',
			'Title'=>$self->{'title'},
			'contains'=>[]);

    push (@{$classifyinfo{'contains'}}, {'OID'=>$self->{'url'}});

    return \%classifyinfo;
}


1;
