/**********************************************************************
 *
 * documentaction.h -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: documentaction.h 443 1999-08-10 22:40:01Z sjboddie $
 *
 *********************************************************************/


#ifndef DOCUMENTACTION_H
#define DOCUMENTACTION_H

#include "action.h"
#include "gsdlconf.h"
#include "formattools.h"

class documentaction : public action {

protected:


  virtual void output_text (const ResultDocInfo_t &docinfo, format_t *formatlistptr,
			    const TermInfo_tarray &terminfo, const text_t &OID,
			    bool highlight, const text_t &hastxt, int wanttext, 
			    text_t &collection, recptproto *collectproto, displayclass &disp, 
			    outconvertclass &outconvert, ostream &textout, 
			    ostream &logout);

  virtual void output_document (const text_t &OID, cgiargsclass &args, 
				recptproto *collectproto, displayclass &disp, 
				outconvertclass &outconvert, ostream &textout, 
				ostream &logout);

  void highlighttext(text_t &text, const TermInfo_tarray &terms, 
		     displayclass &disp, outconvertclass &outconvert, 
		     ostream &textout, ostream &logout);

  formatinfo_t formatinfo;
  

public:
  documentaction ();
  virtual ~documentaction ();

  bool init (ostream &logout);

  text_t get_action_name () {return "d";}

  bool check_cgiargs (cgiargsinfoclass &argsinfo, cgiargsclass &args, 
		      ostream &logout);

  void get_cgihead_info (cgiargsclass &args, response_t &response,
                         text_t &response_data, ostream &logout);

  void define_external_macros (const ColInfoResponse_t &collectinfo, displayclass &disp, 
			       cgiargsclass &args, recptproto *collectproto, 
			       ostream &logout);

  void define_internal_macros (const ColInfoResponse_t &collectinfo, displayclass &disp, 
			       cgiargsclass &args, recptproto *collectproto, 
			       ostream &logout);

  bool do_action (cgiargsclass &args, const ColInfoResponse_t &collectinfo, 
		  recptproto *collectproto, displayclass &disp, 
		  outconvertclass &outconvert, ostream &textout, 
		  ostream &logout);

};



#endif


