/**********************************************************************
 *
 * pingaction.cpp -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: pingaction.cpp 421 1999-07-30 02:24:45Z sjboddie $
 *
 *********************************************************************/

/*
   $Log$
   Revision 1.3  1999/07/30 02:24:45  sjboddie
   added collectinfo argument to some functions

   Revision 1.2  1999/02/25 21:58:59  rjmcnab

   Merged sources.

   Revision 1.1  1999/02/21 22:35:20  rjmcnab

   Initial revision.

 */


#include "pingaction.h"

pingaction::pingaction () {
  // this action uses cgi variable "a"
  cgiarginfo arg_ainfo;
  arg_ainfo.shortname = "a";
  arg_ainfo.longname = "action";
  arg_ainfo.multiplechar = true;
  arg_ainfo.defaultstatus = cgiarginfo::weak;
  arg_ainfo.argdefault = "ping";
  arg_ainfo.savedarginfo = cgiarginfo::must;

  argsinfo.addarginfo (NULL, arg_ainfo);

}

void pingaction::get_cgihead_info (cgiargsclass &/*args*/, response_t &response,
				   text_t &response_data, ostream &/*logout*/) {
  response = content;
  response_data = "text/html";
}


bool pingaction::do_action (cgiargsclass &args, const ColInfoResponse_t &/*collectinfo*/, 
			    recptproto *collectproto, displayclass &/*disp*/, 
			    outconvertclass &outconvert, ostream &textout, 
			    ostream &logout) {
  bool wassuccess = false;
  comerror_t err;
  
  if (!args["c"].empty() && (collectproto != NULL)) {
    collectproto->ping (args["c"], wassuccess, err, logout);
    if (err != noError) wassuccess = false; // a communication error
  }

  textout << outconvert
	  << "<html>\n"
	  << "<head>\n"
	  << "<title>Ping</title>\n"
	  << "</head>\n"
	  << "<body>\n"
	  << "Ping for \"" << args["c"] << "\" ";

  if (wassuccess) {
    textout << outconvert << " succeeded.\n";
  } else {
    textout << outconvert << " did not succeed.\n";
  }

  textout << outconvert 
	  << "</body>\n"
	  << "</html>\n";

  return true;
};
