/**********************************************************************
 *
 * tipaction.cpp -- define random tip macros
 * Copyright (C) 1999  DigiLib Systems Limited, New Zealand
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: tipaction.cpp 421 1999-07-30 02:24:45Z sjboddie $
 *
 *********************************************************************/

/*
   $Log$
   Revision 1.2  1999/07/30 02:24:45  sjboddie
   added collectinfo argument to some functions

   Revision 1.1  1999/07/09 02:18:27  rjmcnab
   Initial revision.


 */


#include "tipaction.h"
#include <stdlib.h>


void tipaction::define_external_macros (const ColInfoResponse_t &/*collectinfo*/, displayclass &disp, 
					cgiargsclass &/*args*/, recptproto */*collectproto*/, 
					ostream &logout) {

  // define_external_macros sets the following macros:

  // _tip:thistip_
  
  // get the maximum tip number (_tip:tipmax_)
  text_t tipmax_str;
  disp.expandstring ("tip", "_tipmax_", tipmax_str);
  if (tipmax_str.empty()) {
    logout << "Warning: _tip:tipmax_ not set. This macro is needed for displaying tips.\n";
    return;
  }
    
  int tipmax = tipmax_str.getint();
  if (tipmax < 1) {
    logout << "Warning: _tip:tipmax_ was less than 1. No tips were set.\n";
    return;
  }

  disp.setmacro("thistip", "tip", "_tip" + text_t((rand()%tipmax) + 1) + "_");
}

